<template>
  <div class="tab" v-show="isShowTab" >
    <div class="tab-content">
      <template
        v-if="field.textType == 'hidden'"
      >
        <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      </template>

      <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
        <!-- 可编辑 -->
        <template v-if="field.showMode == '1'">
          <div v-for="(tab,index) in field.tabs" :key="tab.id">
            <div class="tab-item" @click="showTab(tab.id)" v-show="tab.displayType != Constant.PermissionType_HIDDEN">
              <span>{{tab.name}}</span>
              <span class="icon" v-if="tab.isOpenAll">
                <i class="fa fa-angle-down"></i>
              </span>
              <span class="icon" v-else>
                <i class="fa fa-angle-up"></i>
              </span>
            </div>
            <template>
              <component 
                v-show="tab.isOpenAll"
                class="tab-content" 
                name="formTemplate" 
                v-bind="$attrs"
                v-on="$listeners"
                :is="template(index,tab.id)">
              </component>
            </template>
          </div>
        </template>
        <template v-if="field.showMode=='0' || field.showMode == '2' ">
          <div class="scrollbar" ref="box">
            <ul class="list" ref="ulBox">
              <li
                v-for="(tab,index) in field.tabs"
                :key="tab.id"
                @click="test(index)"
                :ref="'li'+index"
              >
                <span v-if="tab.displayType !=3 " :class="active==index?'active':''">{{tab.name}}</span>
              </li>
            </ul>
          </div>
          <div class="page-tab-container">
            <mt-tab-container
              class="page-tabbar-tab-container"
              v-model="active"
              swipeable
            >
              <mt-tab-container-item :id="index" v-for="(tab,index) in field.tabs" :key="tab.id">
                <component 
                  v-if="active == index"
                  class="tab-content" 
                  name="formTemplate" 
                  @getFormdata="getbuildFormdata"
                  :is="template(index,tab.id)">
                </component>
              </mt-tab-container-item>
            </mt-tab-container>
          </div>
        </template>
      </template>

      <template
        v-else-if="field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED"
      >
        <template v-if="field.showMode == '1'">
          <div v-for="(tab,index) in field.tabs" :key="tab.id">
            <div class="tab-item" @click="showTab(tab.id)" v-show="tab.displayType != Constant.PermissionType_HIDDEN">
              <span>{{tab.name}}</span>
              <span class="icon" v-if="tab.isOpenAll">
                <i class="fa fa-angle-down"></i>
              </span>
              <span class="icon" v-else>
                <i class="fa fa-angle-up"></i>
              </span>
            </div>
            <template>
              <component 
                v-show="tab.isOpenAll"
                class="tab-content" 
                name="formTemplate" 
                :is="template(index,tab.id)">
              </component>
            </template>
            
          </div>
        </template>
        <template v-if="field.showMode=='0'  || field.showMode == '2' ">
          <div class="scrollbar" ref="box">
            <ul class="list" ref="ulBox">
              <li
                v-for="(tab,index) in field.tabs"
                :key="tab.id"
                @click="test(index)"
                :ref="'li'+index"
              >
                <span v-if="tab.displayType !=3 " :class="active==index?'active':''">{{tab.name}}</span>
              </li>
            </ul>
          </div>
          <div class="page-tab-container">
            <mt-tab-container
              class="page-tabbar-tab-container"
              v-model="active"
              swipeable
              value="tab-container1"
            >
              <mt-tab-container-item :id="index" v-for="(tab,index) in field.tabs" :key="tab.id">
                <component 
                  v-if="active == index"
                  class="tab-content" 
                  name="formTemplate" 
                  :is="template(index,tab.id)">
                </component>
              </mt-tab-container-item>
            </mt-tab-container>
          </div>
        </template>
      </template>
    </div>
  </div>
</template>

<script>
import o_tab_view from "@/components/o_tab_view.vue"
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-tab",
  props: ["id"],
  components: { o_tab_view },
  computed: {
    field() {
      let formData = this.$parent.findField(this.id);
      return this.setField(formData);
    }
  },
  
  watch: {
    tabList(arr) {
      this.setTabList(arr);
    },
    active(newVal) {
      if (this.$refs[`li${newVal}`]) {
        let liWidth = this.$refs[`li${newVal}`][0].offsetLeft;
        let screenWidth =
          window.innerWidth ||
          document.documentElement.clientWidth ||
          document.body.clientWidth;
        let halfWidth = parseInt(screenWidth / 2);
        if (liWidth > halfWidth) {
          this.$refs[`box`].scrollLeft = 
            liWidth - halfWidth + this.$refs[`li${newVal}`][0].clientWidth / 2;
        } else {
          this.$refs[`box`].scrollLeft = 0;
        }
      }
    },
    
  },

  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return {
      Constant,
      collapseNames: [],
      isOpenAll: true,
      viewId: "",
      selected: "1",
      active: 0,
      tabList: "",
      isShowTab: true,//选项卡是否隐藏
    };
  },

  methods: {
    getbuildFormdata() {
      //this.$emit("getFormdata");
    },
    showTab(id) {
      let data = this.field.tabs;
      for(let i=0; i<data.length; i++) {
        if(data[i].id == id) {
          data[i].isOpenAll = !data[i].isOpenAll;
          this.$forceUpdate();
          return;
        }
      }
      //
    },
    setField(data) {
      this.isShowTab = true;
      for(let i=0; i<data.tabs.length; i++) { //此循环删除隐藏的tab标签，
        if(data.tabs.length == 1) {
          if(data.tabs[i].displayType == 3) {
            this.isShowTab = false //当选项卡里的tabs长度为1时，整个样式类tab隐藏，超过1时不隐藏
            data.tabs.splice(i, 1);
            i--;
          }
        }else {
          if(data.tabs[i].displayType == 3) {
            data.tabs.splice(i, 1);
            i--;
          }
        }
      }
      this.tabList = data;
      if(data.showMode == '1') {
        if(data.tabs && data.tabs.length > 0) {
          for(let i=0; i<data.tabs.length; i++) {
            if(data.openAll == "true") {
              data.tabs[i].isOpenAll = true
            }else if(data.openAll == "false"){
              data.tabs[i].isOpenAll = false
            }
          }
        }
        
      }else {
         if (data.tabs && data.tabs.length > 0) {
          for (let i = 0; i < data.tabs.length; i++) {
            if(data.tabs[i].selected) {
              this.active = i;
            }
          }
        }
      }
      return data;
    },
    setTabList(arr) {
      if (arr.tabs && arr.tabs.length > 0) {
        for (let i = 0; i < arr.tabs.length; i++) {
          if (arr.tabs[i].displayType == 3) {  //隐藏
            if (i == 0) {
              this.active = i + 1;

            } else if (i > 0) {
              if (
                arr.tabs[i - 1].displayType &&
                arr.tabs[i - 1].displayType != 3
              ) {
                this.active = i - 1;
                return;
              } else {
                this.active = i + 1;
              }
            }
          }
        }
      }
    },
    test(id) {
      this.active = id;
    },
   
    template(index) {
      let data = this.field.tabs[index];
      if (data && data.fields) {
        let fields = data.fields;
        let mobileTmpl = this.$common.convertTemplate(fields);
        return {
          methods: {
            findField(id) {
              for (let i = 0; i < data.fields.length; i++) {
                let fld = data.fields[i];
                if (id == fld.id) return fld;
              }
              return null;
            },
            checkData(){
              return this.$parent.$parent.$parent.$parent.checkData();
            },
            // getAllFields(){
            //   return this.$parent.$parent.$parent.$parent.getAllFields();
            // }
          },
          template: "<div>" + mobileTmpl + "</div>"
        };
      } else if (data.type == "view") {
        let viewId = data.id;
        let showtype = "tab";
        let parentId = data.docId;
        let isRelate = data.relate;
        let formId = this.field.formId;
        let id = this.id;
        let displayType = data.displayType;
        return {
          components: { o_tab_view },
          methods: {
            getParams() {
              return {
                appId: this.$root.appid,
                actionContent: viewId,
                showtype: showtype,
                parentId:parentId,
                isRelate:isRelate,
                formId:formId,
                id:id,
                includeDisplayType: displayType,
              };
            }
          },
          template: "<div><o_tab_view :openParams='getParams()' :includeDisplayType='getParams().includeDisplayType'/></div>"
          //template:"<div><button @click='params()'>视图</button></div>"
        };
        // return {
        //   template: "<div>empty</div>"
        // };
      } else {
        return {
          template: "<div>empty</div>"
        };
      }
    }
  }
};
</script>
